<template>
    <div class="content">
        <div class="intro-y flex flex-col sm:flex-row items-center my-8">
            <div class="mr-auto">
                <h2 class="text-lg font-medium mr-auto">
                    Management User
                </h2>
            </div>
        </div>
        <div class="grid grid-cols-12 gap-6 mt-5">
            <div class="intro-y col-span-12 lg:col-span-6">
                <!-- BEGIN: Form Layout -->
                <div class="intro-x box p-5">
                    <form @submit.prevent="submit">
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Username</label>
                            <input id="crud-form-1" type="text" class="form-control w-full" placeholder="Input Username"
                                v-model="username" :disabled="edit">
                        </div>
                        <div v-show="!edit">
                            <label for="crud-form-1" class="form-label mt-2">Password</label>
                            <input id="crud-form-1" type="password" class="form-control w-full"
                                placeholder="Input Password" v-model="password">
                        </div>
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Email</label>
                            <input id="crud-form-1" type="text" class="form-control w-full" placeholder="Input Email"
                                v-model="email">
                        </div>
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Name</label>
                            <input id="crud-form-1" type="text" class="form-control w-full" placeholder="Input Name"
                                v-model="name">
                        </div>
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Department</label>
                            <select class="tom-select w-full" v-model="department" data-placeholder="Select Department">
                                <option v-for="item in departments" :value="item" :key="item">{{item}}</option>
                            </select>
                        </div>
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Role</label>
                            <select class="tom-select w-full" v-model="role" data-placeholder="Select Role">
                                <option v-for="item in roles" :value="item" :key="item">{{item}}</option>
                            </select>
                        </div>
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Level</label>
                            <select class="tom-select w-full" v-model="level" data-placeholder="Select Role">
                                <option v-for="item in levels" :value="item" :key="item">{{item}}</option>
                            </select>
                        </div>
                        <div>
                            <label for="crud-form-1" class="form-label mt-1">Profile</label>
                            <input id="crud-form-1" type="file" class="form-control w-full" ref="file"
                                v-on:change="handleFileUpload()">
                        </div>
                        <div class="text-right mt-5">
                            <a type="button" class="btn btn-outline-secondary w-24 mr-1"
                              href="/user">Cancel</a>
                            <button type="submit" class="btn btn-primary w-24">{{label}}</button>
                        </div>
                    </form>
                </div>
                <!-- END: Form Layout -->
            </div>
        </div>
    </div>
</template>

<script>
    import Toastify from 'toastify-js';

    export default {
        name: 'FormUser',
        data() {
            return {
                username: "",
                password: "",
                email: "",
                name: "",
                roles: ["admin", "user", "head department"],
                role: "",
                levels: [],
                level: "",
                departments: [],
                department: "",
                file: "",
                edit: false,
                label: "Save",
                fieldEmpty: [],
                error: "",
                id: 0,
                user: null
            }
        },
        created: function () {
            var splitUrl = this.$route.path.split("/");
            if (splitUrl[1] == "edit-user") {
                this.edit = true
                this.id = splitUrl[2]
                this.label = "Edit"
            }
            this.getDepartment()
            this.getLevel()
        },
        methods: {
            async getDepartment() {
                const res = await this.$axios.get("/organizer/code", {
                    headers: {
                        "Token": this.$store.state.user.token,
                        "User-ID": this.$store.state.user.user_id
                    }
                })
                let data = res.data.data
                for (let x = 0; x < data.length; x++) {
                    const element = data[x];
                    this.departments.push(element.name)
                }
            },
            async getLevel() {
                const res = await this.$axios.get("/role/code", {
                    headers: {
                        "Token": this.$store.state.user.token,
                        "User-ID": this.$store.state.user.user_id
                    }
                })
                let data = res.data.data
                for (let x = 0; x < data.length; x++) {
                    const element = data[x];
                    this.levels.push(element.name)
                }
            },
            async getDetail() {
                this.$axios.get(`/user/${this.id}/detail`, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    })
                    .then((response) => {
                        const data = response.data.data

                        if (this.departments.find(x => x != data.info.department)) {
                            this.departments.push(data.info.department)
                        }

                        if (this.levels.find(x => x != data.info.level)) {
                            this.levels.push(data.info.level)
                        }

                        this.user = data
                        this.username = data.username
                        this.email = data.email
                        this.name = data.info.name
                        this.department = data.info.department
                        this.role = data.info.role
                        this.level = data.info.level
                    }).catch(error => {
                        console.log(error);
                    });
            },
            handleFileUpload() {
                this.file = this.$refs.file.files[0];
            },
            reset() {
                this.username = this.user.username
                this.email = this.user.email
                this.name = this.user.info.name
                this.department = this.user.info.department
                this.role = this.user.info.role
                this.level = this.user.info.level
            },
            submit: function () {
                if (this.username == "") {
                    this.fieldEmpty.push('username')
                }

                if (this.password == "" && this.label != "Edit") {
                    this.fieldEmpty.push('password')
                }

                if (this.email == "") {
                    this.fieldEmpty.push('email')
                }

                if (this.name == "") {
                    this.fieldEmpty.push('name')
                }

                if (this.department == "") {
                    this.fieldEmpty.push('department')
                }

                if (this.role == "") {
                    this.fieldEmpty.push('role')
                }

                if (this.level == "") {
                    this.fieldEmpty.push('level')
                }

                if (this.fieldEmpty.length > 0) {

                    this.error = this.fieldEmpty.join(" & ")
                    this.error += ` is empty`

                    Toastify({
                        text: `ERROR : ${this.error}`,
                        duration: 3000,
                        newWindow: true,
                        close: true,
                        gravity: "top",
                        position: "right",
                        stopOnFocus: true,
                        className: "toastify-content",
                    }).showToast();

                    this.fieldEmpty = []
                    this.error = ""
                    return
                }

                if (this.edit) {
                    let formData = new FormData();
                    formData.append('profile', this.file)
                    formData.append("email", this.email)
                    formData.append("name", this.name)
                    formData.append("department", this.department)
                    formData.append("role", this.role)
                    formData.append("level", this.level)

                    this.$axios.put(`/user/${this.id}/update`, formData, {
                        headers: {
                            'Content-Type': 'multipart/form-data',
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    }).then(() => {
                        Toastify({
                            text: `Update User Success`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                        this.$router.push({
                            name: 'data-user'
                        })
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
                } else {
                    let formData = new FormData();
                    formData.append('profile', this.file)
                    formData.append('username', this.username)
                    formData.append("password", this.password)
                    formData.append("email", this.email)
                    formData.append("name", this.name)
                    formData.append("department", this.department)
                    formData.append("role", this.role)
                    formData.append("level", this.level)

                    this.$axios.post("/user", formData, {
                        headers: {
                            'Content-Type': 'multipart/form-data',
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    }).then(() => {
                        Toastify({
                            text: `Create User Success`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();

                        this.$router.push({
                            name: 'data-user'
                        })
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
                }
            }
        },
        mounted() {

            if (this.edit) {
                this.getDetail()
            }

        }
    }
</script>